'------------------------------------------------------------------------
'                          Hesari.vbs (v3.5)
'------------------------------------------------------------------------
' - Run "RunMeInBackground" -function in order to get your data updated.
'
' - Use "Add text file" -meter to view.
'
' - You may change user variable below.
'
'                              				- Meitzi
'
Option Explicit
Function RunMeInBackground(SHOW_TIME_TRUE_FALSE) 'TRUE = Include timestamp, anything else = not

'------------------------------------------------------------------
'----------------------- User variables ---------------------------
'------------------------------------------------------------------

	Const OtsikkoMaara	= 5		'Montako uutisotsikko haetaan. Max 25

'------------------------------------------------------------------

	dim htmlResult,outputti,uutinen,kello,relnext, i, aloitus, lopetus, SHOW_TIME
	
	If SHOW_TIME_TRUE_FALSE = TRUE Or ucase(SHOW_TIME_TRUE_FALSE) = "TRUE" Or SHOW_TIME_TRUE_FALSE = "1" Then SHOW_TIME = TRUE

	htmlResult = ReturnHTML("http://www.hs.fi/uutiset/rss")

	relnext = instr(htmlResult, "/image") 'Tll pstn kivasti Otsikon ohi
	if relnext > 1 then
		for i = 1 to OtsikkoMaara
			aloitus = instr( relnext, htmlResult, "<title>") + 7
			if aloitus < 10 then exit for
			lopetus = instr( aloitus, htmlResult, "</title>")
			if lopetus <= aloitus then exit for
			uutinen = Trim(mid( htmlResult, aloitus, lopetus-aloitus ))
			aloitus = instr( lopetus, htmlResult, "</pubDate>") - 14
			lopetus = instr( aloitus, htmlResult, "</pubDate>") - 9
			if SHOW_TIME = TRUE then kello = " " & mid( htmlResult, aloitus, lopetus-aloitus )
			outputti = outputti & uutinen & kello & "%b"
			relnext = lopetus
		next
	end if

	outputti = replace(outputti, chr(10), "")
	outputti = replace(outputti, chr(13), " ")
	outputti = replace(outputti, "&amp;", chr(38))
	outputti = replace(outputti, "&quot;", chr(34))
	outputti = replace(outputti, "&nbsp;", chr(32))
	outputti = replace(outputti, "&ndash;", "")
	outputti = replace(outputti, "&#xD;", "")

	aloitus = Instr(outputti, "&#")
	Do While aloitus > 0 'Korvataan kaikki &#xx; vastaavalla merkill
		lopetus = Instr(aloitus, outputti, ";")
		If lopetus - aloitus > 0 and  lopetus - aloitus < 7 Then
			I = Int(mid(outputti, aloitus +2, lopetus - aloitus -2))
			If I > 255 Then I = 45 'Miten pitisi hoitaa? Esim &#8211;
			If I > 0 Then outputti = left(outputti, aloitus-1) & Chr(I) & right(outputti, len(outputti) - lopetus)
		End If
		aloitus = Instr(aloitus+2, outputti, "&#")
	Loop

	RunMeInBackground = outputti
End Function

Private Function ReturnHTML(sURL)
	Dim objHttp
	Set objHttp = CreateObject("Msxml2.ServerXMLHTTP")
	On Error Resume Next
	objHttp.Open "GET", sURL, False
	objHttp.Send
	if err = 0 then
		ReturnHTML = objHttp.ResponseText
	else
		ReturnHTML = "Network error"
	end if
	On Error GoTo 0
	Set objHttp = Nothing
End Function
